import { Entity } from './entity.base';

export interface Mapper<
  DomainEntity extends Entity<any>,
  DbReadRecord,
  DbWriteRecord,
  Response = any,
> {
  toPersistence(entity: DomainEntity): DbWriteRecord;
  toDomain(record: DbReadRecord): DomainEntity;
  toResponse(entity: DomainEntity): Response;
}
