import { Command, CommandProps } from '@libs/ddd';
import { Frequency } from '@modules/ad/core/ad.types';
import { Schedule } from '../../types/schedule';
import { MarginDurations } from '../../types/margin-durations';
import { Waypoint } from '../../types/waypoint';

export class CreateAdCommand extends Command {
  readonly userId: string;
  readonly driver?: boolean;
  readonly passenger?: boolean;
  readonly frequency?: Frequency;
  readonly fromDate: string;
  readonly toDate: string;
  readonly schedule: Schedule;
  readonly marginDurations?: MarginDurations;
  readonly seatsProposed?: number;
  readonly seatsRequested?: number;
  readonly strict?: boolean;
  readonly waypoints: Waypoint[];

  constructor(props: CommandProps<CreateAdCommand>) {
    super(props);
    this.userId = props.userId;
    this.driver = props.driver;
    this.passenger = props.passenger;
    this.frequency = props.frequency;
    this.fromDate = props.fromDate;
    this.toDate = props.toDate;
    this.schedule = props.schedule;
    this.marginDurations = props.marginDurations;
    this.seatsProposed = props.seatsProposed;
    this.seatsRequested = props.seatsRequested;
    this.strict = props.strict;
    this.waypoints = props.waypoints;
  }
}
