import { ResponseBase } from '@libs/api/response.base';
import { Frequency } from '@modules/ad/core/ad.types';

export class AdResponseDto extends ResponseBase {
  userId: string;
  driver: boolean;
  passenger: boolean;
  frequency: Frequency;
  fromDate: string;
  toDate: string;
  schedule: {
    mon?: string;
    tue?: string;
    wed?: string;
    thu?: string;
    fri?: string;
    sat?: string;
    sun?: string;
  };
  marginDurations: {
    mon?: number;
    tue?: number;
    wed?: number;
    thu?: number;
    fri?: number;
    sat?: number;
    sun?: number;
  };
  seatsProposed: number;
  seatsRequested: number;
  strict: boolean;
  waypoints: {
    position: number;
    name?: string;
    houseNumber?: string;
    street?: string;
    postalCode?: string;
    locality?: string;
    country: string;
    lon: number;
    lat: number;
  }[];
}
