import { ScheduleDto } from '@modules/ad/interface/grpc-controllers/dtos/schedule.dto';
import { IsSchedule } from '@modules/ad/interface/grpc-controllers/dtos/validators/decorators/is-schedule.decorator';
import { Validator } from 'class-validator';

describe('schedule decorator', () => {
  class MyClass {
    @IsSchedule()
    schedule: ScheduleDto;
  }
  it('should return a property decorator has a function', () => {
    const isSchedule = IsSchedule();
    expect(typeof isSchedule).toBe('function');
  });
  it('should validate a valid schedule', async () => {
    const myClassInstance = new MyClass();
    myClassInstance.schedule = {
      mon: '07:15',
    };
    const validator = new Validator();
    const validation = await validator.validate(myClassInstance);
    expect(validation.length).toBe(0);
  });
  it('should not validate a invalid schedule', async () => {
    const myClassInstance = new MyClass();
    myClassInstance.schedule = {};
    const validator = new Validator();
    const validation = await validator.validate(myClassInstance);
    expect(validation.length).toBe(1);
  });
});
